#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#define DS_PORT    PORTD
#define DS_PIN_COL     4
#define DS_PIN_ROW     5
#define ST_CP_PORT PORTD
#define ST_CP_PIN  1
#define SH_CP_PORT PORTD
#define SH_CP_PIN  0
 
#define DS_low_c()  DS_PORT&=~_BV(DS_PIN_COL)
#define DS_high_c() DS_PORT|=_BV(DS_PIN_COL)

#define DS_low_r()  DS_PORT&=~_BV(DS_PIN_ROW)
#define DS_high_r() DS_PORT|=_BV(DS_PIN_ROW)

#define ST_CP_low()  ST_CP_PORT&=~_BV(ST_CP_PIN)
#define ST_CP_high() ST_CP_PORT|=_BV(ST_CP_PIN)
#define SH_CP_low()  SH_CP_PORT&=~_BV(SH_CP_PIN)
#define SH_CP_high() SH_CP_PORT|=_BV(SH_CP_PIN)
 
//Define functions
//======================
void ioinit(void);
void output_led_row(unsigned char __led_state[10]);
void output_led_col(unsigned char __led_state[8]);

//======================
 

 
int main (void){

	ioinit(); //Setup IO pins and defaults
	unsigned char leds_col[8] =  {0,0,0,0,0,0,1,0};
	unsigned char leds_row[10] = {1,1,1,1,1,1,1,1,0,1};
 
	while(1){
		
		
		output_led_col(leds_col);
		output_led_row(leds_row);
		_delay_ms(100);
   }
}
 
 
void ioinit (void){
    DDRD  = 0b00110011; //1 = output, 0 = input
    PORTD = 0b00000000;
}

// functie pt shiftare a bitilor pentru cele 32 de leduri 
void output_led_col(unsigned char __led_state[8]){	
	int j;
	SH_CP_low();
	ST_CP_low();
	for (j = 0; j < 8; ++j){
	  
		if (__led_state[j])
			DS_high_c();
		else  
			DS_low_c();
	 
 
		SH_CP_high();
		SH_CP_low();
	}
	
	ST_CP_high();
}

void output_led_row(unsigned char __led_state[10]){	
	int j;
	SH_CP_low();
	ST_CP_low();
	for (j = 0; j < 10; ++j){
	  
		if (__led_state[j])
			DS_high_r();
		else  
			DS_low_r();
	 
 
		SH_CP_high();
		SH_CP_low();
	}
	
	ST_CP_high();
}